summaryrefslogtreecommitdiff
path: root/tests/rm/inaccessible
diff options
context:
space:
mode:
Diffstat (limited to 'tests/rm/inaccessible')
-rwxr-xr-xtests/rm/inaccessible76
1 files changed, 76 insertions, 0 deletions
diff --git a/tests/rm/inaccessible b/tests/rm/inaccessible
new file mode 100755
index 0000000..02128d7
--- /dev/null
+++ b/tests/rm/inaccessible
@@ -0,0 +1,76 @@
+#!/bin/sh
+# Ensure that rm works even when run from a directory
+# for which the user has no access at all.
+
+# Copyright (C) 2004, 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ rm --version
+fi
+
+PRIV_CHECK_ARG=require-non-root . $srcdir/../priv-check
+. $srcdir/../lang-default
+
+# Skip this test if your system has neither the openat-style functions
+# nor /proc/self/fd support with which to emulate them.
+skip=yes
+grep '^#define HAVE_OPENAT' $CONFIG_HEADER > /dev/null && skip=no
+test -d /proc/self/fd && skip=no
+if test $skip = yes; then
+ echo 1>&2 "$0: no openat support, so skipping this test"
+ (exit 77); exit 77
+fi
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+mkdir abs1 abs2 no-access || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+p=$pwd/$tmp
+set +x
+(cd no-access; chmod 0 . && rm -r "$p/abs1" rel "$p/abs2") 2> out && fail=1
+test -d "$p/abs1" && fail=1
+test -d "$p/abs2" && fail=1
+
+cat <<\EOF > exp || fail=1
+rm: cannot remove `rel': Permission denied
+EOF
+
+# AIX 4.3.3 fails with a different diagnostic.
+# Transform their diagnostic
+# ...: The file access permissions do not allow the specified action.
+# to the expected one:
+sed 's/: The file access permissions.*/: Permission denied/'<out>o1;mv o1 out
+
+cmp out exp || fail=1
+test $fail = 1 && diff out exp 2> /dev/null
+
+(exit $fail); exit $fail